## gensio 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(gensio VERSION 2.2.0)
set (gensio_VERSION_STRING "${gensio_VERSION_MAJOR}.${gensio_VERSION_MINOR}.${gensio_VERSION_PATCH}")

include_directories("${PROJECT_BINARY_DIR}" "${PROJECT_SOURCE_DIR}/include"
                    "${PROJECT_BINARY_DIR}/include")

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(GNUInstallDirs)

set (CMAKE_C_FLAGS "-Wall")
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

option(USE_UUCP_LOCKING "Enable UUCP lock file handling for devices" ON)

option(ENABLE_TCP_WRAPPERS "Enable tcpwrappers support" ON)
if(ENABLE_TCP_WRAPPERS)
  CHECK_INCLUDE_FILE(tcpd.h HAVE_TCPD_H)
  if(HAVE_TCPD_H)
    list(APPEND EXTRA_LIBS wrap)
   endif()
endif()

option(ENABLE_PTHREADS "Enable pthreads" ON)
set(USE_PTHREADS 0)
if(ENABLE_PTHREADS)
  CHECK_LIBRARY_EXISTS(pthread "pthread_create" "" PTHREAD_LIB_FOUND)
  CHECK_INCLUDE_FILE(pthread.h PTHREAD_INC_FOUND)
  if(PTHREAD_LIB_FOUND AND PTHREAD_INC_FOUND)
    set(USE_PTHREADS 1)
    list(APPEND EXTRA_LIBS pthread)
  endif()
endif()

option(ENABLE_EPOLL "Enable epoll support" ON)
if(ENABLE_EPOLL)
  CHECK_INCLUDE_FILE(sys/epoll.h HAVE_EPOLL_PWAIT)
endif()

option(ENABLE_OPENIPMI "Enable OpenIPMI serial over LAN support" ON)
if(ENABLE_OPENIPMI)
  CHECK_LIBRARY_EXISTS(OpenIPMI "ipmi_alloc_os_handler" "" OPENIPMI_LIB_FOUND)
  CHECK_INCLUDE_FILE(OpenIPMI/ipmiif.h OPENIPMI_INC_FOUND)
  if(OPENIPMI_LIB_FOUND AND OPENIPMI_INC_FOUND)
    set(HAVE_OPENIPMI 1)
    if(USE_PTHREADS)
      list(APPEND EXTRA_LIBS OpenIPMI OpenIPMIpthread OpenIPMIutils)
    else()
      list(APPEND EXTRA_LIBS OpenIPMI OpenIPMIposix OpenIPMIutils)
    endif()
  endif()
endif()

option(ENABLE_OPENSSL "Enable openssl" ON)
set(HAVE_OPENSSL 0)
if(ENABLE_OPENSSL)
  CHECK_LIBRARY_EXISTS(ssl "SSL_connect" "" SSL_LIB_FOUND)
  CHECK_LIBRARY_EXISTS(crypto "X509_verify_cert" "" CRYPTO_LIB_FOUND)
  CHECK_INCLUDE_FILE(openssl/ssl.h SSL_INC_FOUND)
  CHECK_INCLUDE_FILE(openssl/x509.h CRYPTO_INC_FOUND)
  if(SSL_LIB_FOUND AND SSL_INC_FOUND AND CRYPTO_LIB_FOUND AND CRYPTO_INC_FOUND)
    set(HAVE_OPENSSL 1)
    list(APPEND EXTRA_LIBS ssl crypto)
  endif()
endif()

option(ENABLE_MDNS "Enable MDNS" ON)
set(HAVE_AVAHI 0)
if(ENABLE_MDNS)
  CHECK_LIBRARY_EXISTS(avahi-client "avahi_client_new" "" AVAHI_CLI_LIB_FOUND)
  CHECK_LIBRARY_EXISTS(avahi-common "avahi_malloc" "" AVAHI_COM_LIB_FOUND)
  CHECK_INCLUDE_FILE(avahi-client/client.h AVAHI_CLI_INC_FOUND)
  CHECK_INCLUDE_FILE(avahi-common/malloc.h AVAHI_COM_INC_FOUND)
  if(AVAHI_CLI_LIB_FOUND AND AVAHI_CLI_INC_FOUND AND AVAHI_COM_LIB_FOUND AND AVAHI_COM_INC_FOUND)
    set(HAVE_AVAHI 1)
    list(APPEND EXTRA_LIBS avahi-client avahi-common)
  endif()
endif()

option(ENABLE_SWIG "Enable swig support" ON)
if(ENABLE_SWIG)
  find_package(SWIG)
endif()

option(ENABLE_PYTHON "Enable python support" ON)
if(ENABLE_PYTHON)
  set (Python_ADDITIONAL_VERSIONS 3 2)
  find_package(PythonInterp)
  find_package(PythonLibs)
  # FIXME - we are assuming this for now.
  option(PYTHON_HAS_POSIX_THREADS "Support threading in python" ON)
endif()

option(ENABLE_SCTP "Enable SCTP support" ON)
if(ENABLE_SCTP)
  CHECK_LIBRARY_EXISTS(sctp "sctp_bindx" "" HAVE_LIBSCTP)
  if (HAVE_LIBSCTP)
    list(APPEND EXTRA_LIBS sctp)
  endif()
endif()
if(HAVE_LIBSCTP)
  CHECK_LIBRARY_EXISTS(sctp "sctp_sendv" "" HAVE_SCTP_SENDV)
endif()

string(COMPARE EQUAL "${CMAKE_HOST_SYSTEM_NAME}" "Linux" HAVE_WORKING_PORT0)

CHECK_LIBRARY_EXISTS(pam "pam_start" "" HAVE_PAM)

check_symbol_exists(TIOCSRS485 sys/ioctl.h HAVE_DECL_TIOCSRS485)

CHECK_INCLUDE_FILE(sys/un.h HAVE_UNIX)

option(USE_FILE_STDIO "Use stdio instead of unix files for the file gensio"
       ${MSVC})

option(ENABLE_INTERNAL_TRACE
       "Enable internal trace tools, required for oomtest"
       OFF)

set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set (includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set (VERSION "${PROJECT_VERSION}")

check_c_source_compiles("int main()
{
	static int counter = 0;
	int val;

	__atomic_load(&counter, &val, __ATOMIC_SEQ_CST);
	return val;
}" HAVE_GCC_ATOMICS)

check_symbol_exists(isatty unistd.h HAVE_ISATTY)
check_symbol_exists(strcasecmp string.h HAVE_STRCASECMP)
check_symbol_exists(strncasecmp string.h HAVE_STRNCASECMP)
check_symbol_exists(prctl sys/prctl.h HAVE_PRCTL)
check_symbol_exists(getrandom sys/random.h HAVE_GETRANDOM_FUNC)
set (CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE")
check_symbol_exists(ptsname_r "stdlib.h" HAVE_PTSNAME_R)
check_symbol_exists(cfmakeraw "termios.h" HAVE_CFMAKERAW)
check_symbol_exists(signalfd "signalfd.h" HAVE_SIGNALFD)
check_symbol_exists(regexec "regex.h" HAVE_REGEXEC)
check_symbol_exists(fnmatch "fnmatch.h" HAVE_FNMATCH)

if(UNIX)
  set(HAVE_STDIO 1)
  set(HAVE_SERIALDEV 1)
  set(HAVE_PTY 1)
else()
  set(HAVE_STDIO 0)
  set(HAVE_SERIALDEV 0)
  set(HAVE_PTY 0)
endif()

configure_file(config.h.cmake config.h)

add_subdirectory(lib)
add_subdirectory(include)
add_subdirectory(tools)
add_subdirectory(examples)
if(SWIG_FOUND)
  add_subdirectory(swig)
endif()
add_subdirectory(man)
if(UNIX)
add_subdirectory(tests)
endif()

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${gensio_VERSION_MAJOR}.${gensio_VERSION_MINOR}.${gensio_VERSION_PATCH}")
set(CPACK_SOURCE_IGNORE_FILES "/.git/;/Z.*/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== tests/CMakeLists.txt ===

enable_testing()

add_executable(oomtest oomtest.c)
target_link_libraries(oomtest gensio)

set (top_srcdir "${CMAKE_SOURCE_DIR}")
set (top_builddir "${CMAKE_BINARY_DIR}")
configure_file(runtest.in runtest @ONLY)
configure_file(gensios_enabled.py.in gensios_enabled.py @ONLY)

add_test(NAME syncio
         COMMAND runtest test_syncio.py)
set_tests_properties(syncio PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME echo
         COMMAND runtest test_echo_gensio.py)
set_tests_properties(echo PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME echo_device
         COMMAND runtest test_echo_device.py)
set_tests_properties(echo_device PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME serial_pipe_device
         COMMAND runtest test_serial_pipe_device.py)
set_tests_properties(serial_pipe_device PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_tcp
         COMMAND runtest test_accept_tcp.py)
set_tests_properties(accept_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_udp
         COMMAND runtest test_accept_udp.py)
set_tests_properties(accept_udp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_sctp
         COMMAND runtest test_accept_sctp.py)
set_tests_properties(accept_sctp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_ssl_tcp
         COMMAND runtest test_accept_ssl_tcp.py)
set_tests_properties(accept_ssl_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_certauth_tcp
         COMMAND runtest test_accept_certauth_tcp.py)
set_tests_properties(accept_certauth_tcp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME accept_mux_sctp
         COMMAND runtest test_accept_mux_sctp.py)
set_tests_properties(accept_mux_sctp PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet
         COMMAND runtest test_telnet.py)
set_tests_properties(telnet PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME modemstate
         COMMAND runtest test_modemstate.py)
set_tests_properties(modemstate PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio
         COMMAND runtest test_stdio_basic.py)
set_tests_properties(stdio PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio_stderr
         COMMAND runtest test_stdio_basic_stderr.py)
set_tests_properties(stdio_stderr PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME stdio_small
         COMMAND runtest test_stdio_small.py)
set_tests_properties(stdio_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_small
         COMMAND runtest test_tcp_small.py)
set_tests_properties(tcp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_urgent
         COMMAND runtest test_tcp_urgent.py)
set_tests_properties(tcp_urgent PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME pty
         COMMAND runtest test_pty_basic.py)
set_tests_properties(pty PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_small
         COMMAND runtest test_sctp_small.py)
set_tests_properties(sctp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_streams
         COMMAND runtest test_sctp_streams.py)
set_tests_properties(sctp_streams PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_oob
         COMMAND runtest test_sctp_oob.py)
set_tests_properties(sctp_oob PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet_small
         COMMAND runtest test_telnet_small.py)
set_tests_properties(telnet_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ipmisol_small
         COMMAND runtest test_ipmisol_small.py)
set_tests_properties(ipmisol_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ipmisol_large
         COMMAND runtest test_ipmisol_large.py)
set_tests_properties(ipmisol_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME rs485
         COMMAND runtest test_rs485.py)
set_tests_properties(rs485 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME tcp_accept_connect
         COMMAND runtest test_tcp_accept_connect.py)
set_tests_properties(tcp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME unix_accept_connect
         COMMAND runtest test_unix_accept_connect.py)
set_tests_properties(unix_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME udp_accept_connect
         COMMAND runtest test_udp_accept_connect.py)
set_tests_properties(udp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME sctp_accept_connect
         COMMAND runtest test_sctp_accept_connect.py)
set_tests_properties(sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME telnet_sctp_accept_connect
         COMMAND runtest test_telnet_sctp_accept_connect.py)
set_tests_properties(telnet_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME ssl_sctp_accept_connect
         COMMAND runtest test_ssl_sctp_accept_connect.py)
set_tests_properties(ssl_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME certauth_sctp_accept_connect
         COMMAND runtest test_certauth_sctp_accept_connect.py)
set_tests_properties(certauth_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME certauth_ssl_sctp_accept_connect
         COMMAND runtest test_certauth_ssl_sctp_accept_connect.py)
set_tests_properties(certauth_ssl_sctp_accept_connect PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_sctp_small
         COMMAND runtest test_mux_sctp_small.py)
set_tests_properties(mux_sctp_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_tcp_large
         COMMAND runtest test_mux_tcp_large.py)
set_tests_properties(mux_tcp_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_limits
         COMMAND runtest test_mux_limits.py)
set_tests_properties(mux_limits PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME mux_oob
         COMMAND runtest test_mux_oob.py)
set_tests_properties(mux_oob PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt
         COMMAND runtest test_relpkt_basic.py)
set_tests_properties(relpkt PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_small
         COMMAND runtest test_relpkt_small.py)
set_tests_properties(relpkt_small PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_medium
         COMMAND runtest test_relpkt_medium.py)
set_tests_properties(relpkt_medium PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME relpkt_large
         COMMAND runtest test_relpkt_large.py)
set_tests_properties(relpkt_large PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME test_udp_nocon
         COMMAND runtest test_udp_nocon.py)
set_tests_properties(relpkt_large PROPERTIES SKIP_RETURN_CODE 77)

add_test(NAME oomtest0
         COMMAND runtest oomtest -t 0 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest0 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest1
         COMMAND runtest oomtest -t 1 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest1 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest2
         COMMAND runtest oomtest -t 2 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest2 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest3
         COMMAND runtest oomtest -t 3 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest3 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest4
         COMMAND runtest oomtest -t 4 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest4 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest5
         COMMAND runtest oomtest -t 5 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest5 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest6
         COMMAND runtest oomtest -t 6 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest6 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest7
         COMMAND runtest oomtest -t 7 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest7 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest8
         COMMAND runtest oomtest -t 8 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest8 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest9
         COMMAND runtest oomtest -t 9 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest9 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest10
         COMMAND runtest oomtest -t 10 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest10 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest11
         COMMAND runtest oomtest -t 11 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest11 PROPERTIES SKIP_RETURN_CODE 77)
add_test(NAME oomtest12
         COMMAND runtest oomtest -t 12 ${PROJECT_BINARY_DIR}/tools/gensiot)
set_tests_properties(oomtest12 PROPERTIES SKIP_RETURN_CODE 77)

#
# If you get certauth fuzz failures, they will be in the
# fuzz-results-certauth/crashes or fuzz-results-certauth/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand certauth-randfile -i echo 'certauth(CA=ca/clientcert.pem,allow-unencrypted,mode=server),file(infile="fuzz-results-certauth/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_certauth
   COMMAND rm -rf fuzz-test-certauth fuzz-results-certauth
   COMMAND mkdir -p fuzz-test-certauth
   COMMAND mkdir -p fuzz-results-certauth
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot certauth-randfile
		"'certauth(cert=ca/clientcert.pem,key=ca/clientkey.pem,allow-unencrypted)'"
		"'certauth(CA=ca/clientcert.pem,allow-unencrypted)'"
		fuzz-test-certauth/tracefile
   COMMAND afl-fuzz -i fuzz-test-certauth -o fuzz-results-certauth
		-f certauth-infile
		${PROJECT_BINARY_DIR}/tools/gensiot --dummyrand certauth-randfile
		-i echo
		"'certauth(CA=ca/clientcert.pem,allow-unencrypted,mode=server),file(infile=certauth-infile)'"
)

#
# If you get mux fuzz failures, they will be in the
# fuzz-results-mux/crashes or fuzz-results-mux/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand mux-randfile -i echo 'mux(writebuf=10000,mode=server),file(infile="fuzz-results-mux/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_mux
   COMMAND rm -rf fuzz-test-mux fuzz-results-mux
   COMMAND mkdir -p fuzz-test-mux
   COMMAND mkdir -p fuzz-results-mux
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot mux-randfile
		"mux" "mux"
		fuzz-test-mux/tracefile
   COMMAND afl-fuzz -i fuzz-test-mux -o fuzz-results-mux
		-f mux-infile
		${PROJECT_BINARY_DIR}/tools/gensiot --dummyrand mux-randfile
		-i echo
		"'mux,file(infile=mux-infile)'"
)

#
# If you get ssl fuzz failures, they will be in the
# fuzz-results-ssl/crashes or fuzz-results-ssl/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand ssl-randfile -i echo 'ssl(key=ca/key.pem,cert=ca/cert.pem,mode=server),file(infile="fuzz-results-ssl/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_ssl
   COMMAND rm -rf fuzz-test-ssl fuzz-results-ssl
   COMMAND mkdir -p fuzz-test-ssl
   COMMAND mkdir -p fuzz-results-ssl
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot ssl-randfile
		"'ssl(CA=ca/CA.pem)'"
		"'ssl(key=ca/key.pem,cert=ca/cert.pem)'"
		fuzz-test-ssl/tracefile
   COMMAND afl-fuzz -i fuzz-test-ssl -o fuzz-results-ssl
		-f ssl-infile
		${PROJECT_BINARY_DIR}/tools/gensiot --dummyrand ssl-randfile
		-i echo
		"'ssl(key=ca/key.pem,cert=ca/cert.pem,mode=server),file(infile=ssl-infile)'"
)

#
# If you get telnet fuzz failures, they will be in the
# fuzz-results-telnet/crashes or fuzz-results-telnet/hangs directories.
# To reproduce the failure, in this directory, run:
#
# ../tools/gensiot --dummyrand telnet-randfile -i echo 'telnet(mode=server),file(infile="fuzz-results-telnet/[hangs|crashes]/<file>")'
#
# where the <file> is the specific failure.
#
add_custom_target(test_fuzz_telnet
   COMMAND rm -rf fuzz-test-telnet fuzz-results-telnet
   COMMAND mkdir -p fuzz-test-telnet
   COMMAND mkdir -p fuzz-results-telnet
   COMMAND ./runtest test_fuzz_setup.py
		${PROJECT_BINARY_DIR}/tools/gensiot telnet-randfile
		"telnet" "telnet"
		fuzz-test-telnet/tracefile

=== debian/changelog ===
gensio (2.2.0-2build1) hirsute; urgency=medium

  * No-change rebuild to build with python3.9 as default.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Nov 2020 18:31:46 +0100

gensio (2.2.0-2) unstable; urgency=medium

  * upload to unstable

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sat, 14 Nov 2020 09:10:50 +0100

gensio (2.2.0-1) experimental; urgency=medium

  * Second try of initial upload to experimental (Closes: #971031)
  * new upstream version 2.2.0
  * remove local patches that upstream accepted
  * enable additional features via ./configure parameters
  * build python binding packages
  * disable upstream tests (they require an out-of-tree kernel module)
  * improve debian/copyright

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Wed, 28 Oct 2020 21:07:32 +0100

gensio (2.1.5-1) experimental; urgency=medium

  * Initial upload to experimental (Closes: #971031)
  * python parts of package still missing
  * test turned off (fail due to python missing)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 27 Sep 2020 16:25:02 +0200

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with python3,autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-tcp-wrappers \
		--with-openssl \
		--with-avahi \
		--with-swig \
		--with-python

override_dh_auto_clean:
	dh_auto_clean
	rm -rf tests/__pycache__

# disable the upstream tests, they depend on an out-of-tree kernel module
override_dh_auto_test:
	true

## gensio 2.2.3

=== debian/changelog ===
gensio (2.2.3-1) unstable; urgency=medium

  * new upstream version 2.2.3
  * update debian/copyright
  * install more manpages

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 15 Nov 2020 20:29:14 +0100

## gensio 2.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.10)
 
-project(gensio VERSION 2.2.0)
+project(gensio VERSION 2.2.4)
 set (gensio_VERSION_STRING "${gensio_VERSION_MAJOR}.${gensio_VERSION_MINOR}.${gensio_VERSION_PATCH}")
 
 include_directories("${PROJECT_BINARY_DIR}" "${PROJECT_SOURCE_DIR}/include"

=== examples/CMakeLists.txt ===
add_executable(basic_client basic_client.c)
target_link_libraries(basic_client gensio)

add_executable(basic_server basic_server.c)
target_link_libraries(basic_server gensio)

add_executable(basic_server_sync basic_server_sync.c)
target_link_libraries(basic_server_sync gensio)

if(UNIX)
add_executable(basic_server_sync_fork basic_server_sync_fork.c)
target_link_libraries(basic_server_sync_fork gensio)
endif()

=== lib/CMakeLists.txt ===
option(ALSOSTATIC "When buiding a shared library, build a static one, too")

set(BASE_LIBFILES
  buffer.c
  gensio_net.c
  gensio_filter_telnet.c
  gensio_ssl.c
  gensio_acc.c
  gensio_filter_trace.c
  gensio_acc_gensio.c
  gensio_trace.c
  gensio_base.c
  gensio_ll_gensio.c
  gensio_ll_fd.c
  gensio_udp.c
  gensio.c
  gensio_ll_ipmisol.c
  gensio_certauth.c
  gensio_msgdelim.c
  sergensio.c
  gensio_dummy.c
  gensio_mux.c
  sergensio_ipmisol.c
  gensio_echo.c
  gensio_file.c
  sergensio_telnet.c
  gensio_filter_certauth.c
  telnet.c
  gensio_filter_msgdelim.c
  gensio_relpkt.c
  utils.c
  gensio_filter_relpkt.c
  gensio_sctp.c
  gensio_filter_ssl.c
  gensio_perf.c
  gensio_filter_perf.c
  gensio_conacc.c
  errtrig.c
  mdns.c
  avahi_watcher.c
  gensio_mdns.c)

set(UNIX_LIBFILES
  gensio_stdio.c
  selector.c
  sergensio_serialdev.c
  uucplock.c
  gensio_pty.c
  gensio_osops.c
  gensio_selector.c)

if(UNIX)
  set(LIBFILES ${BASE_LIBFILES} ${UNIX_LIBFILES})
else()
  set(LIBFILES ${BASE_LIBFILES})
endif()

add_library(gensio ${LIBFILES})
if(BUILD_SHARED_LIBS AND ALSOSTATIC)
  add_library(gensio-static STATIC ${LIBFILES})
  SET_TARGET_PROPERTIES(gensio-static PROPERTIES OUTPUT_NAME gensio
                        CLEAN_DIRECT_OUTPUT 1)
  install(TARGETS gensio-static DESTINATION lib)
endif()
target_link_libraries(gensio ${EXTRA_LIBS})
set_property(TARGET gensio PROPERTY VERSION 0.0.0)
set_property(TARGET gensio PROPERTY SOVERSION 0)

install(TARGETS gensio DESTINATION lib EXPORT gensio)
install(EXPORT gensio FILE gensio.cmake DESTINATION lib/cmake/gensio)
target_include_directories(gensio
                           INTERFACE
                            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                            $<INSTALL_INTERFACE:include>
                           )

configure_file(libgensio.pc.in libgensio.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libgensio.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== man/CMakeLists.txt ===

install(FILES gensio.5 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5)

install(FILES gensio_event.3 str_to_gensio.3 gensio_set_callback.3
	gensio_set_log_mask.3 gensio_os_funcs.3 gensio_err.3 gensio_write.3
	gensio_get_raddr.3 gensio_raddr_to_str.3 gensio_open.3
	gensio_alloc_channel.3 gensio_close.3 gensio_control.3
	gensio_set_read_callback_enable.3 gensio_get_type.3 gensio_set_sync.3
	gensio_accepter_event.3 gensio_acc_set_callback.3
	gensio_acc_shutdown.3 gensio_acc_set_accept_callback_enable.3
	gensio_acc_control.3 gensio_acc_get_type.3 gensio_add_default.3
	str_to_gensio_accepter.3 gensio_acc_accept_s.3 gensio_acc_startup.3
	gensio_mdns.3
	DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man3)

macro(install_man3_symlink filepath sympath)
    install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${filepath} ${CMAKE_INSTALL_FULL_MANDIR}/man3/${sympath})")
    install(CODE "message(\"-- Created symlink: ${sympath} -> ${filepath}\")")
endmacro(install_man3_symlink)

install_man3_symlink(str_to_gensio.3 str_to_gensio_child.3)
install_man3_symlink(str_to_gensio.3 gensio_acc_str_to_gensio.3)
install_man3_symlink(gensio_set_callback.3 gensio_set_user_data.3)
install_man3_symlink(gensio_set_callback.3 gensio_get_user_data.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_get_log_mask.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_log_level_to_str.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_vlog.3)
install_man3_symlink(gensio_set_log_mask.3 gensio_log.3)
install_man3_symlink(gensio_os_funcs.3 gensio_default_os_hnd.3)
install_man3_symlink(gensio_err.3 gensio_err_to_str.3)
install_man3_symlink(gensio_write.3 gensio_write_sg.3)
install_man3_symlink(gensio_open.3 gensio_open_s.3)
install_man3_symlink(gensio_open.3 gensio_open_nochild.3)
install_man3_symlink(gensio_open.3 gensio_open_nochild_s.3)
install_man3_symlink(gensio_close.3 gensio_close_s.3)
install_man3_symlink(gensio_close.3 gensio_disable.3)
install_man3_symlink(gensio_close.3 gensio_free.3)
install_man3_symlink(gensio_set_read_callback_enable.3
		     gensio_set_write_callback_enable.3)
install_man3_symlink(gensio_get_type.3 gensio_get_child.3)
install_man3_symlink(gensio_get_type.3 gensio_is_client.3)
install_man3_symlink(gensio_get_type.3 gensio_is_reliable.3)
install_man3_symlink(gensio_get_type.3 gensio_is_packet.3)
install_man3_symlink(gensio_get_type.3 gensio_is_message.3)
install_man3_symlink(gensio_get_type.3 gensio_is_authenticated.3)
install_man3_symlink(gensio_get_type.3 gensio_is_encrypted.3)
install_man3_symlink(gensio_set_sync.3 gensio_clear_sync.3)
install_man3_symlink(gensio_set_sync.3 gensio_read_s.3)
install_man3_symlink(gensio_set_sync.3 gensio_write_s.3)
install_man3_symlink(str_to_gensio_accepter.3 str_to_gensio_accepter_child.3)
install_man3_symlink(gensio_acc_set_callback.3 gensio_acc_set_user_data.3)
install_man3_symlink(gensio_acc_set_callback.3 gensio_acc_get_user_data.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_shutdown_s.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_disable.3)
install_man3_symlink(gensio_acc_shutdown.3 gensio_acc_free.3)
install_man3_symlink(gensio_acc_set_accept_callback_enable.3
		     gensio_acc_set_accept_callback_enable_cb.3)
install_man3_symlink(gensio_acc_set_accept_callback_enable.3
		     gensio_acc_set_accept_callback_enable_s.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_reliable.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_packet.3)
install_man3_symlink(gensio_acc_get_type.3 gensio_acc_is_message.3)
install_man3_symlink(gensio_add_default.3 gensio_set_default.3)
install_man3_symlink(gensio_add_default.3 gensio_get_default.3)
install_man3_symlink(gensio_add_default.3 gensio_get_defaultaddr.3)
install_man3_symlink(gensio_add_default.3 gensio_del_default.3)
install_man3_symlink(gensio_add_default.3 gensio_reset_defaults.3)
install_man3_symlink(gensio_acc_accept_s.3 gensio_acc_set_sync.3)
install_man3_symlink(gensio_mdns.3 gensio_alloc_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_free_mdns.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_service.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_add_watch.3)
install_man3_symlink(gensio_mdns.3 gensio_mdns_remove_watch.3)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -175,6 +175,12 @@
 add_test(NAME oomtest12
          COMMAND runtest oomtest -t 12 ${PROJECT_BINARY_DIR}/tools/gensiot)
 set_tests_properties(oomtest12 PROPERTIES SKIP_RETURN_CODE 77)
+add_test(NAME oomtest13
+         COMMAND runtest oomtest -t 13 ${PROJECT_BINARY_DIR}/tools/gensiot)
+set_tests_properties(oomtest13 PROPERTIES SKIP_RETURN_CODE 77)
+add_test(NAME oomtest14
+         COMMAND runtest oomtest -t 14 ${PROJECT_BINARY_DIR}/tools/gensiot)
+set_tests_properties(oomtest14 PROPERTIES SKIP_RETURN_CODE 77)
 
 #
 # If you get certauth fuzz failures, they will be in the
@@ -259,11 +265,3 @@
 #
 # where the <file> is the specific failure.
 #
-add_custom_target(test_fuzz_telnet
-   COMMAND rm -rf fuzz-test-telnet fuzz-results-telnet
-   COMMAND mkdir -p fuzz-test-telnet
-   COMMAND mkdir -p fuzz-results-telnet
-   COMMAND ./runtest test_fuzz_setup.py
-		${PROJECT_BINARY_DIR}/tools/gensiot telnet-randfile
-		"telnet" "telnet"
-		fuzz-test-telnet/tracefile

=== tools/CMakeLists.txt ===

add_library(gensiotool STATIC ioinfo.c ser_ioinfo.c utils.c localports.c)
set_target_properties(gensiotool PROPERTIES
                      POSITION_INDEPENDENT_CODE OFF)

add_executable(gensiot gensiotool.c)
target_link_libraries(gensiot gensio gensiotool)

install(TARGETS gensiot DESTINATION bin)

install(FILES gensiot.1 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)

if(HAVE_AVAHI)
  add_executable(gmdns gensiomdns.c)
  target_link_libraries(gmdns gensio gensiotool)
  install(TARGETS gmdns DESTINATION bin)
  install(FILES gmdns.1 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)
endif()

if(UNIX)
  add_library(gtlssh-shared STATIC gtlssh-shared.c)
  set_target_properties(gensiotool PROPERTIES
                        POSITION_INDEPENDENT_CODE OFF)

  set (SYSCONFDIR, "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
  configure_file(gtlssh-keygen.in gtlssh-keygen @ONLY)

  add_executable(gtlssh gtlssh.c)
  target_link_libraries(gtlssh gensio gtlssh-shared gensiotool)

  install(TARGETS gtlssh DESTINATION bin)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/gtlssh-keygen DESTINATION bin)
  install(PROGRAMS gtlssync DESTINATION bin)

  install(FILES gtlssh.1 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)
  install(FILES gtlssync.1 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)
  install(FILES gtlssh-keygen.1 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1)

  if(HAVE_PAM)
    add_executable(gtlsshd gtlsshd.c)
    target_compile_definitions(gtlsshd PRIVATE "SYSCONFDIR=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}\"")
    target_link_libraries(gtlsshd gensio gtlssh-shared gensiotool pam)
    install(TARGETS gtlsshd DESTINATION sbin)
    install(FILES gtlsshd.8 DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8)
  endif()
endif()

=== include/gensio/CMakeLists.txt ===
install(FILES gensio.h gensio_class.h sergensio.h sergensio_class.h
	gensio_selector.h waiter.h gensio_base.h gensio_acc_gensio.h
	gensio_ll_fd.h gensio_ll_gensio.h selector.h argvutils.h
	gensio_os_funcs.h gensio_err.h gensio_builtins.h gensio_osops.h
	gensio_list.h gensio_dllvisibility.h gensio_deprecated.h gensio_mdns.h
	DESTINATION include/gensio)

configure_file(gensio_version.h.in gensio_version.h)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gensio_version.h
        DESTINATION include/gensio)

=== swig/python/CMakeLists.txt ===
if(PYTHON_VERSION_MAJOR EQUAL 3)
  set(SWIG_EXTRA_FLAGS -py3)
endif()
include_directories(${PYTHON_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
set(CMAKE_SWIG_FLAGS -I${CMAKE_CURRENT_SOURCE_DIR} ${SWIG_EXTRA_FLAGS})
swig_add_library(gensio LANGUAGE python SOURCES ../gensio.i)
swig_link_libraries(gensio gensio)

execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)
set(PYTHON_INSTALL_SITE_PACKAGES ${PYTHON_SITE_PACKAGES} CACHE FILEPATH
    "The path to install Python packages to")
install(TARGETS _gensio DESTINATION ${PYTHON_INSTALL_SITE_PACKAGES})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gensio.py DESTINATION ${PYTHON_INSTALL_SITE_PACKAGES})

=== debian/changelog ===
gensio (2.2.4-1) unstable; urgency=medium

  * new upstream version 2.2.4

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sat, 06 Feb 2021 11:46:46 +0100

gensio (2.2.3-2) unstable; urgency=medium

  * set CFLAGS/LDFLAGS and hardening flags

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 31 Jan 2021 21:18:37 +0100

=== debian/control ===
Source: gensio
Priority: optional
Maintainer: Marc Haber <mh+debian-packages@zugschlus.de>
Build-Depends: debhelper-compat (= 13), dh-python, swig, python3-dev,
 pkg-config, libssl-dev, libwrap0-dev, libopenipmi-dev, libpam-dev,
 libsctp-dev, libavahi-client-dev
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/cminyard/gensio
Vcs-Browser: https://salsa.debian.org/debian/gensio
Vcs-Git: https://salsa.debian.org/debian/gensio.git
Rules-Requires-Root: no

Package: libgensio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgensio0 (= ${binary:Version}), ${misc:Depends}
Description: abstract stream I/O (development files)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the development headers and static libraries.

Package: libgensio0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: abstract stream I/O (runtime files)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the shared libraries.

Package: python3-gensio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${python3:Provides}
Description: abstract stream I/O (python 3 bindings)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the python 3 bindings.

Package: gensio-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: abstract stream I/O (command line tool)
 This library (pronounced gen'-see-oh) is used to abstract stream I/O
 like serial port, TCP, telnet, UDP, SSL, IPMI SOL etc and offers a
 framework for giving a consistent view of various stream (and packet)
 I/O types. You create a gensio object (or a gensio), and you can use
 that gensio without having to know too much about what is going on
 underneath. You can stack gensio on top of another one to add protocol
 funcionality. For instance, you can create a TCP gensio, stack SSL on
 top of that, and stack Telnet on top of that. It supports a number of
 network I/O and serial ports.  Gensio can be used for sending and
 receiving ports, and it also supports establishing encrypted and
 authenticated connections.
 .
 This package contains the command line tool.

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gensio-$1.tar.gz%" \
   https://github.com/cminyard/gensio/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
